;(function(){
(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'element-ui', './pagination', '../_style/global.css', './style/index.css'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('element-ui'), require('./pagination'), require('../_style/global.css'), require('./style/index.css'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.elementUi, global.pagination, global.global, global.index);
    global.index = mod.exports;
  }
})(this, function (exports, _elementUi, _pagination) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _pagination2 = _interopRequireDefault(_pagination);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _components;

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  exports.default = {
    name: 'uc-table',
    components: (_components = {}, _defineProperty(_components, _elementUi.Table.name, _elementUi.Table), _defineProperty(_components, _elementUi.TableColumn.name, _elementUi.TableColumn), _defineProperty(_components, _elementUi.Button.name, _elementUi.Button), _defineProperty(_components, _pagination2.default.name, _pagination2.default), _components),
    props: {
      tableProps: {
        type: Object,
        default: function _default() {}
      },
      tableEvents: {
        type: Object,
        default: function _default() {}
      },
      columns: { required: true, type: Array },
      options: {
        type: Array,
        default: function _default() {
          return [];
        }
      },
      data: {
        type: Array,
        default: function _default() {
          return [];
        }
      },
      fetch: Function
    },
    data: function data() {
      return {
        loading: false,
        total: 0,
        currentPage: 1,
        pageSize: 10
      };
    },
    watch: {
      data: function data(newVal) {
        if (newVal && newVal.length > 0) {
          this.list = newVal;
        }
      }
    },
    created: function created() {
      var _list = this.list,
          list = _list === undefined ? [] : _list;

      if (list.length === 0) {
        this.loadList();
      }
    },

    methods: {
      loadList: function loadList() {
        try {
          var currentPage = this.currentPage,
              pageSize = this.pageSize;

          this.loading = true;

          var _fetch = this.fetch({ currentPage: currentPage, pageSize: pageSize }),
              list = _fetch.list,
              total = _fetch.total;

          this.list = list;
          this.total = total;

          if (list.length === 0) {
            if (currentPage === 1) {
              this.loading = false;
              return;
            }
            this.currentPage += -1;
            if (this.currentPage <= 1) {
              this.currentPage = 1;
            }
            this.loadList();
          }
        } catch (e) {
          console.log(e);
        }
        this.loading = false;
      },
      refresh: function refresh() {
        this.loadList();
      },
      clearSelection: function clearSelection() {
        this.$refs.table.clearSelection();
      },
      toggleRowSelection: function toggleRowSelection(row) {
        this.$refs.table.toggleRowSelection(row);
      },
      toggleRowExpansion: function toggleRowExpansion(row) {
        this.$refs.table.toggleRowExpansion(row);
      },
      setCurrentRow: function setCurrentRow(row) {
        this.$refs.table.setCurrentRow(row);
      },
      clearSort: function clearSort() {
        this.$refs.table.clearSort();
      },
      clearFilter: function clearFilter() {
        this.$refs.table.clearFilter();
      },
      doLayout: function doLayout() {
        this.$refs.table.doLayout();
      }
    }
  };
});
})()
if (module.exports.__esModule) module.exports = module.exports.default
var __vue__options__ = (typeof module.exports === "function"? module.exports.options: module.exports)
__vue__options__.render = function render () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_c('el-table',_vm._g(_vm._b({directives:[{name:"loading",rawName:"v-loading",value:(_vm.loading),expression:"loading"}],ref:"table",attrs:{"data":_vm.list}},'el-table',_vm.tableProps,false),_vm.tableEvents),[_vm._l((_vm.columns),function(item,idx){return _c('el-table-column',_vm._b({key:idx,attrs:{"prop":item.prop,"label":item.label,"className":item.prop},scopedSlots:_vm._u([{key:"default",fn:function(slotScope){return [(item.slot)?_vm._t(item.slot,null,null,slotScope):_vm._e(),_vm._v(" "),(!item.slot)?_c('span',[_vm._v("\n          "+_vm._s(item.formatter ? (item.formatter(slotScope.row) || '--') : (slotScope.row[item.prop] || '--'))+"\n        ")]):_vm._e()]}}],null,true)},'el-table-column',item.props,false))}),_vm._v(" "),(_vm.options.length)?_c('el-table-column',{attrs:{"label":"操作"},scopedSlots:_vm._u([{key:"default",fn:function(ref){
var row = ref.row;
return _vm._l((_vm.options),function(i,idx){return _c('el-button',{directives:[{name:"show",rawName:"v-show",value:(i.showConfig.rowValues.includes(row[i.showConfig.rowName])),expression:"i.showConfig.rowValues.includes(row[i.showConfig.rowName])"}],key:idx,attrs:{"type":"text"},on:{"click":function($event){return i.onClick(row)}}},[_vm._v("\n          "+_vm._s(i.label)+"\n        ")])})}}],null,false,702586700)}):_vm._e()],2),_vm._v(" "),_c('pagination',{directives:[{name:"show",rawName:"v-show",value:(_vm.total>0),expression:"total>0"}],attrs:{"total":_vm.total,"page":_vm.currentPage,"limit":_vm.pageSize},on:{"update:page":function($event){_vm.currentPage=$event},"update:limit":function($event){_vm.pageSize=$event},"pagination":_vm.loadList}})],1)}
__vue__options__.staticRenderFns = []
